<div align="center">
  <img style="width: 160px; height: auto;" src="public/rw-logo.png" alt="Logo for Strapi preview button plugin" />
  <h1>Strapi Review Workflow</h1>
  <p>A plugin for Strapi CMS that allow task to be review by another user or a member of a role for approval before publishing.</p>
  <img style="width: 960px; height: auto;" src="public/illustration.gif" alt="Gif for Strapi review workflow plugin" />
</div>

## Get Started

* [Terminologies](#terminologies)
* [Features](#features)
* [Installation](#installation)
* [Configuration](#configuration)
* [Support or Donate](#donate)



## <a id="terminologies"></a>📖 Terminologies
**Assignee** - Who will work on the task.

**Approver** - Who will review and approve.

## <a id="features"></a>✨ Features
* Assign collection-types or single-types to a user or a role [all users in the role have access] to work on 🚧
* Assign collection-types or single-types to a user or a role [all users in the role have access] to review for approval ✅
* Only the user or role assigned as the "approver" can change status to "approved"
* Ensure that no content is published without review and approval ❌
* Assignee can't be Approver on the same task except if super-admin 👎
* Approver can't be Assignee on the same task except if super-admin👎



## <a id="installation"></a>💎 Installation
```bash
yarn add strapi-plugin-review-workflow
```

Don't forget to **restart or rebuild** your Strapi app when installing a new plugin.

## <a id="configuration"></a>🔧 Configuration

Add the plugin to the plugins.js/ts  and middlewares.js/ts files in your config folder. If this folder does not exist on your project, you will need to create it.
For more information check the [strapi docs](https://docs.strapi.io/dev-docs/configurations).
```ts
// ./config/plugins.ts
export default ({ env }) => ({

	"review-workflow": {
		enabled: true
	},

});

```
```ts
// ./config/middlewares.ts
export default [

	"plugin::review-workflow.workflow"

];


```
**If the plugin is not added to the middleware, it won't check if the content has been approved before publishing.**



## <a id="donate"></a>❤️ Support or Donate
If you are enjoying this plugin and feel extra appreciative, you can [buy me a ☕️ ](https://www.buymeacoffee.com/obafunmiso).

